; The fast version which skips all the even numbers > 2

; and uses the coprocessor to find SQRT of the

; number we are examining in order to test

; possible divisors only up to that number.

; Since it also uses extended registers it requires

; a 80386+80387 or >= 80486.



; The quickest method is to use DPMI to allocate

; 16M of RAM and then use Erastothenes' sieve

; but I have no time (or the RAM) to code & test that.

; Thanks to the 146 byte guy - you gave me the courage

; to enter mine :-) I hope yours is really fast!

; As I only have a 486DX-33 I have to submit the fast version

; and hope it satisfies the time limitation.

; It takes 101 seconds to find the 100 000th prime on my computer.



; Also INT 20h, VxD 1, service 00ACh converts decimal strings

; to an integer but has the unwanted side-effect of quitting in DOS.



; In 1994, BitZero from IRC's #coders coded a program to display all primes

; "2 3 ... 997" in 43 bytes.  (Search deja.com for "smallest prime generation 

; program" to see some people's effort to do it in C - a thread I

; started had Dennis Ritchie as a contributor.)



shr si,1    ;2 si = 80h

;mov si,80h ; when running in debug, si != 100h to start with

mov cl,[si] ;2 cx = byte ptr [80h]

xor eax,eax ;2 general.txt claims high 16 bits of EAX could be anything

mov ebx,10  ;5 general.txt claims high 16 bits of EBX could be anything

jcxz printt ;2 must handle empty input!

inc si      ;1 

dec cx      ;1



; If you consult Teensypi.asm (see URL below) you'll find out

; that better coders than I consider that the high 16 bits

; of EAX - EDX are all zeros to begin with - so 5 bytes wasted here.



; eax ends up containing 'n'

; at each stage multiply eax by 10

; and add the read byte



lo: 

inc si      ;1

cdq         ;2 set edx to 0

mul ebx     ;3 edx:eax = eax * ebx

mov dl,[si] ;2 edx = 0 since the number input n is < 10 million

sub dl,30h  ;2

add eax,edx ;3

loop lo     ;2

or eax,eax  ;3

jz printt   ;2 if n = 0 output 0

mov ebp,eax ;3

mov eax,2   ;5 start considering 2

dec ebp     ;3

jz printt   ;2 print 2 if n = 1

db 0dbh,0e3h;2 finit w/o preceding wait is ok on 287 and above

inc ax      ;1 start considering 3

here: 

mov [si], eax   ;3

fild dword [si] ;2

fsqrt           ;2

fistp dword [si] ;2

xor ecx,ecx     ;3

inc cx          ;1

here2: 

inc cx          ;1 ecx never goes over 4000, so just inc cx

inc cx          ;1

cmp cx, [si]    ;2 is cx > sqrt(eax)?

ja good         ;2 if so it is prime



;push ecx     ;2 let's check if ecx * ecx > eax

;xchg eax,ecx ;2 uncomment this section for people without coprocessors

;mul eax      ;3

;cmp eax,ecx  ;3

;mov eax,ecx  ;2

;pop ecx      ;2

;ja good      ;2



push eax        ;2

cdq             ;2

div ecx         ;3

or edx,edx      ;3 after diving EAX/ECX, check if remainder (EDX) == 0

pop eax         ;2

jz next         ;2 if it is, EAX is not prime

jmp short here2 ;2

good: 

dec ebp         ;2

jz printt       ;2

next: 

inc eax         ;2

inc eax         ;2

jmp short here  ;2

printt: 

mov cx,10       ;3 print routine from Teensypi.asm

push_loop:      

cdq             ;2 from jasonp's pi page

div ebx         ;3 http://www.isr.umd.edu/~jasonp/Teensypi.asm

push dx         ;1 which prints 9306 decimal digits of pi in 86 bytes

loop push_loop  ;2

mov cl,10       ;2

pop_loop: 

pop dx          ;1

add dl,'0'      ;2

mov ah,2        ;2 competition rules require printing to stdout:

int 21h         ;2 INT 29h does not print to STDOUT so must use INT 21h/AH=2

loop pop_loop   ;2 or INT 21h/AH=9

mov dl,0dh      ;2 the final CR/LF pair

int 21h         ;2 so that redirected STDOUT works

mov dl,0ah      ;2 if the CR/LF pair is not there the program

int 21h         ;2 with redirection doesn't terminate

dosexit:  ret   ;1 quit to DOS

